module mem_hub (input logic             rst,
                 input logic             sys_clk,
                 input logic [3:0]       connected_devices, // manually configured
                 input logic [3:0][7:0]  rx_cmd,       // for routing-related commands
                 input logic [3:0]       rx_cmd_valid,
                 input logic [3:0][7:0]  rx_byte,
                 input logic [3:0]       rx_valid,
                 input logic [3:0][1:0]  rx2tx_dest,   // rx byte's destination
                 input logic [3:0]       tx_ready,     // if tx_byte was read
                 output logic [3:0]      rx_ready,     // if rx_byte was read
                 output logic [3:0][1:0] tx_src,       // tell the tx where the stream is comming from
                 output logic [3:0][7:0] tx_byte,
                 output logic [3:0] tx_valid,
                 output logic [1:0] packet_size); // 4 states for 4 fixed packet sizes
   timeunit 1ns;
   timeprecision 1ps;
   
   // TBD: pre-agree on packet size

   // use the round-robin strat to poll since the routing is much faster
   // NOTE: To expand to more connected_devices, use a hierarchical design
   logic [1:0]           curr_service = 0;

   // src dest byte
   logic [1:0][1:0][7:0] service_buffer;
   logic [3:0]           in_buffer;

   // Core service logic
   always_ff @ (posedge sys_clk) begin
       if (rst) begin
           rx_ready <= '1;
           tx_src <= '0;
           tx_valid <= '0;
           packet_size <= '0;
           service_buffer <= '0;
           curr_service <= '0;
       end else if (rx_valid[curr_service]) begin
           
       end
       
       curr_service <= curr_service + 1;
   end
endmodule // mem_hub
